Subject: Re: mvpp2: incorrect max mtu?

From: "Russell King (Oracle)" <[email-masked]>
Date: Fri, 14 May 2021 18:19:45 +0100

On Fri, May 14, 2021 at 04:25:48PM +0200, Marcin Wojtas wrote:
> Thank your for the information. I will take a look after the weekend.
> To be aligned - what exactly kernel baseline are you using?

That was with 5.11 with these additional mvpp2 patches:

net: mvpp2: add TX FC firmware check
net: mvpp2: set 802.3x GoP Flow Control mode
net: mvpp2: add PPv23 RX FIFO flow control
net: mvpp2: add BM protection underrun feature support
net: mvpp2: add ethtool flow control configuration support
net: mvpp2: add RXQ flow control configurations
net: mvpp2: enable global flow control
net: mvpp2: add FCA RXQ non occupied descriptor threshold
net: mvpp2: add FCA periodic timer configurations
net: mvpp2: increase BM pool and RXQ size
net: mvpp2: add PPv23 version definition
net: mvpp2: always compare hw-version vs MVPP21
net: mvpp2: add CM3 SRAM memory map
dts: marvell: add CM3 SRAM memory to cp11x ethernet device tree
doc: marvell: add CM3 address space and PPv2.3 description
net: marvell: Fixed two spellings,controling to controlling and oen to one
net: mvpp2: prs: improve ipv4 parse flow

I'll also try to work out what's happening, but I think we need to find
out what the correct value for dev->max_mtu should be. That's all rather
convoluted:

	dev->max_mtu = MVPP2_BM_JUMBO_PKT_SIZE;

#define MVPP2_BM_JUMBO_PKT_SIZE MVPP2_RX_MAX_PKT_SIZE(MVPP2_BM_JUMBO_FRAME_SIZE)
#define MVPP2_BM_JUMBO_FRAME_SIZE       10432   /* frame size 9856 */
#define MVPP2_RX_MAX_PKT_SIZE(total_size) \
        ((total_size) - MVPP2_SKB_HEADROOM - MVPP2_SKB_SHINFO_SIZE)

The maximum settable MTU on eth0 (9888) disagrees with the comment
"frame size 9856" by 32 bytes.

I haven't checked to see whether 9856 works yet, because that will
first need me to reboot the machine... which I'll do over the weekend.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 40Mbps down 10Mbps up. Decent connectivity at last!